/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import javax.swing.KeyStroke;
import entreesSorties.MathGraphDataOutputStream;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ActionFichierEnregistrer extends MtgAction {
	public ActionFichierEnregistrer(MtgFrame frameInit) {
		super(frameInit, null, getString("chaineMenuFichierEnregistrer"), getString("chaineTipFichierEnregistrer"), null,
				KeyStroke.getKeyStroke("control S"));
	}

	@Override // Ajout version 4.3
  public boolean estDansBarreHorizontale() {
  	return true;
  }
	
	public void actionPerformed(ActionEvent e) {
		if (frame.cadreActif().document.estDocumentVersionC) {
			frame.dialogueAvertissement(getString("ch153"));
			frame.actionFichierEnregistrerSous.actionPerformed(e);
		}
		enregistreFigure();
	}
	
	/**
	 * Fonction enregistrant la figure et renvoyant true seulement si l'enregisrement a t accept
	 * et s'est bien pass
	 * @return
	 */
	public boolean enregistreFigure() {
		File file;
		MtgInternalFrame cadre = frame.cadreActif();
		if (cadre != null) {
	  	if (cadre.path != null) {
	  		file = new File(cadre.path);
	  	}
	  	else {
	  		return ((ActionFichierEnregistrerSous) frame.actionFichierEnregistrerSous).enregistreSous();
	  	}
			try {
				FileOutputStream fos = new FileOutputStream(file);
				MathGraphDataOutputStream oups = new MathGraphDataOutputStream(fos);
				try {
					try {
						cadre.document.write(oups);
					}
					finally {
						oups.close();
					}
					cadre.document.setDirty(false);
				} 
				catch (IOException e1) {
					frame.dialogueAvertissement(getString("ch45"));
					return false;
				}
			} catch (FileNotFoundException e2) {
				frame.dialogueAvertissement(getString("ch45"));
				return false;
			}
	  	
		}
		frame.activeOutilCapture();
		return true;
	}
	
}
