/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.event.ActionEvent;
import java.awt.print.PageFormat;
import java.awt.print.Pageable;
import java.awt.print.Paper;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import javax.swing.KeyStroke;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
/**
 * Cette classe implmente pageable de faon  ce que le nombre de pages  imprimer soit 0
 * ce qui dsactive le choix des pages  imprimer
 */
public class ActionFichierImprimer extends MtgAction implements Pageable {
  PrinterJob pj = null;
	PageFormat pf;
	
	public ActionFichierImprimer(MtgFrame frameInit) {
		super(frameInit, null, getString("chaineMenuFichierImprimer"), getString("chaineTipFichierImprimer"), null,
				KeyStroke.getKeyStroke("control P"));
	}
	
	@Override // Ajout version 4.3
  public boolean estDansBarreHorizontale() {
  	return true;
  }	

	public void actionPerformed(ActionEvent e) {
    if (pj == null) {        
    	pj = PrinterJob.getPrinterJob();
    	pf = pj.defaultPage();
    }

    MtgInternalFrame cadre = frame.cadreActif();
		if (cadre != null) {
		
	    Paper paper = new Paper();
	    // double margin = 36;
	    // paper.setImageableArea(margin, margin, paper.getWidth() - margin * 2, paper.getHeight()
	    //     - margin * 2);
	    paper.setImageableArea(0, 0, paper.getWidth(), paper.getHeight());
	    pf.setPaper(paper);

	    pj.setPageable(this);
	    if (pj.printDialog()) {
	      try {
	        pj.print();
	      } catch (PrinterException exc) {
	      	frame.dialogueAvertissement(getString("ch120"));
	      }
	    }
		}
	}

  @Override
  public int idMenu() {
    return 57607;
  }

	public int getNumberOfPages() {
		// TODO Auto-generated method stub
		return 1;
	}

	public PageFormat getPageFormat(int arg0) throws IndexOutOfBoundsException {
		// TODO Auto-generated method stub
		return pf;
	}

	public Printable getPrintable(int arg0) throws IndexOutOfBoundsException {
		MtgInternalFrame cadre = frame.cadreActif();
		return cadre.paneFigure;
	}
	
}
