/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.event.ActionEvent;
import dialogs.FigureBaseDlg;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ActionFichierNouvelleFigurePredefinie extends MtgAction {
	public ActionFichierNouvelleFigurePredefinie(MtgFrame frameInit) {
		super(frameInit, null, getString("chaineMenuFigureBase"), null, null, null);
	}

	public void actionPerformed(ActionEvent e) {
		// Spcial version Applet : on regarde si la figure prcdente a t modifie et si oui on demande confirmation
		MtgInternalFrame cadreActif = frame.cadreActif();
		if (cadreActif.document.isDirty()) {
			if (!frame.dialogueConfirmation_YES_NO(getString("ch184"))) return;
		}
		cadreActif.retireComposants(); // Ajout version 4.5.2
		FigureBaseDlg dlg = new FigureBaseDlg(frame);
		dlg.setLocationRelativeTo(null);
		dlg.setVisible(true);
	}

}
