/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.event.ActionEvent;
import java.io.IOException;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CMathGrafDoc;

@SuppressWarnings("serial")
public class ActionFichierNouvelleFigureSansLongueurUnite extends MtgAction {
	public ActionFichierNouvelleFigureSansLongueurUnite(MtgFrame frameInit) {
		super(frameInit, null, getString("chaineMenuFichierNouvelleFigureSanslongueurUnite"), null,
				null, null);
	}
	
	public void actionPerformed(ActionEvent e) {
		// Modification version 3.5 : Si la prcdente fentre a t maximise, on maximise la nouvelle
		MtgInternalFrame cadreActif = frame.cadreActif();
		if (cadreActif.document.isDirty()) {
			if (!frame.dialogueConfirmation_YES_NO(getString("ch184"))) return;
		}
		cadreActif.retireComposants(); // Ajout version 4.5.2
		// boolean maximise = cadreActif == null ? false : cadreActif.isMaximum(); Supprim version Applet		
		CMathGrafDoc doc = new CMathGrafDoc(frame);
		doc.listePrincipale.ajouteConstantePi();
		doc.listePrincipale.uniteAngle = frame.pref_angleUnit;
		// MtgInternalFrame cadre = new MtgInternalFrame(frame, "MathGraph" + Integer.toString(frame.instanceNouvelleFenetre()), doc); // Supprim version Applet
		// Dimension sizefen = new Dimension(cadre.getWidth(), cadre.getHeight()); Supprim version Applet
		try {
			cadreActif.gestionnaire.initialise();
		} catch (IOException e1) {}
		// frame.mtgDesktopPane.add(cadre); Supprim version Applet
		// Modification version 3.5.1
		/*
		frame.mtgDesktopPane.getDesktopManager().activateFrame(cadre);
		try {
			cadre.setSelected(true);
		} catch (PropertyVetoException e1) {
		}
		if (maximise) {
			try {
				cadre.setMaximum(true);
			} catch (PropertyVetoException e1) {
				frame.mtgDesktopPane.getDesktopManager().maximizeFrame(cadre);
			}
		}
		else {
			frame.preparePositionPourFenenetre(sizefen);
			cadre.setLocation(frame.xfenetre, frame.yfenetre);
		}
		*/
		cadreActif.setDocument(doc);
		frame.metAJourIconesEtMenus(doc);
		// cadreActif.redessineSansCalcul(); // Modifi version 4.7.2.1 pour envoyer un oordre repaint
		frame.redraw();
		frame.activeOutilCapture();
		// On cre si ncessaire un item de menu dans le menu Fenetres pour activer cete fentre
		/* supprim version Applet
		int nfen = frame.nombreCadresOuverts();
		if (nfen <= MtgFrame.nombreFenetresDansMenu) {
			MtgMenuFileItem item = new MtgMenuFileItem(cadre);
			frame.menuFenetre.add(item);
		}
		else if (nfen == MtgFrame.nombreFenetresDansMenu + 1) frame.menuFenetre.add(frame.itemChoixFenetre);
		*/
	}
}
