/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.event.ActionEvent;
import java.net.MalformedURLException;
import java.net.URL;
import javax.swing.KeyStroke;
import netscape.javascript.JSObject;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class ActionHelpHelp extends MtgAction {
	public ActionHelpHelp(MtgFrame frameInit) {
		super(frameInit, null, getString("chaineMenuHelpHelp"), null, null, KeyStroke.getKeyStroke("F1"));
	}

	// Ajout version 4.3 pour que l'outil puisse tre activ ou non
  @Override
  public int idMenu() {
    return 32022;
  }
	

	// Modifi pour la version Applet
	public void actionPerformed(ActionEvent e) {
		String chURL = "http://mathgraph32.org/Help/";
		if (frame.pref_language.equals("fra")) chURL = chURL + "Helpfra/MathGraph32Help.htm";
		else
		if (frame.pref_language.equals("eng")) chURL = chURL + "Helpeng/MathGraph32Help.htm";
		else
		if (frame.pref_language.equals("esp")) chURL = chURL + "Helpesp/MathGraph32Help.htm";
		
		// Si la page internet contient une fonction javascript metGetHelpURL renvoyant l'adresse d'une page d'aide,
		// c'est celle-l qu'on utilise.
		try {
			JSObject jso = JSObject.getWindow(this.frame);
			chURL = (String) jso.call("mtgGetHelpURL", null);
		}
		catch (Exception exc) {
			// TODO: handle exception
		}
		
		try {
			frame.getAppletContext().showDocument(new URL(chURL), "_blank");
		} catch (MalformedURLException e1) {
			// TODO Auto-generated catch block
		}	
	}
	
	/* Pas utilis version Applet
	private void messageErreur() {
		frame.dialogueAvertissement(getString("ch157"));
	}
	*/
}
