/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;
import java.awt.event.ActionEvent;

import entreesSorties.MathGraphDataOutputStream;

import objets.CMathGrafDoc;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ActionSuppressionImageFond extends MtgAction {

  public ActionSuppressionImageFond(MtgFrame frameInit) {
    super(frameInit, null, getString("chaineMenuSupprimerImageFond"), null, null, null);
  }
	
  @Override
  public int idMenu() {
    return 32026;
  }
  
	public void actionPerformed(ActionEvent e) {
		if (!actionAllowed()) return;
		MtgInternalFrame cadre = frame.cadreActif();
    CMathGrafDoc doc = cadre.document;
    if (doc.imageFond == null) frame.dialogueAvertissement(getString("messageOutilPasDisponible"));
    else {
    	if (frame.dialogueConfirmation_YES_NO(getString("confSupImageFond"))) {
	    	doc.imageFond = null;
	    	doc.natImageFond = MathGraphDataOutputStream.nat_noImage;
	    	// Ligne suivante ajoute version 4.4.4 car si le mode Trace est actif il faut effacer le buffer de traces
	    	cadre.effacetBuffer();
	    	cadre.redessineSansCalcul();
	  		// Version 4.4 : Si on n'appelle pas paintImmediatly seule la rgion situe sous le menu est mise  jour
	  		// cadre.paneFigure.paintImmediately(0, 0, cadre.dimf.longueurAbscisses, cadre.dimf.longueurOrdonnees);
	  		// Modifi version 4.6
	  		cadre.repaintFigureImmediatly();
	    }
    }
	}
}
