/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import types.FonteNom;

import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class AffichageObjetsNumeriquesDlg extends MtgDlg {
  private ListeObjetsNumeriquesEtReperes listeVal;
  private JButton btnFermer;
  private JTextArea info;
  private JScrollPane scrollPaneListe, scrollPaneInfo;

  public AffichageObjetsNumeriquesDlg(MtgFrame frameInit) {
    super(getString("affichageValeursNumeriquesDlg1"), true, frameInit);
    initComponents();
    getRootPane().setDefaultButton(btnFermer);
  }
  
  private void initComponents() {
    btnFermer = new JButton(getString("btnFermer"));
  	btnFermer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        dispose();
        frame.activeOutilCapture();
      }
    });
  	// Spcial version applet
    // listeVal = new ListeObjetsNumeriquesEtReperes(frame.cadreActif().listePr, frame.cadreActif().listePr.size() - 1, false);
  	listeVal = new ListeObjetsNumeriquesEtReperes(frame.listePourConstruction(), frame.listePourConstruction().size() - 1, false);
    listeVal.addListSelectionListener(new ListSelectionListener() {
      public void valueChanged(ListSelectionEvent evt) {
      	listeValSelectionChanged();
      }
    });
    scrollPaneListe = new JScrollPane(listeVal, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    info = new JTextArea();
    info.setFont(FonteNom.getFonteNom(2, FonteNom.Normal, -1));    
    scrollPaneInfo = new JScrollPane(info, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    info.setEditable(false);
    info.setColumns(20);
    info.setEditable(false);
    info.setLineWrap(false);
    info.setRows(4);
    scrollPaneInfo.setPreferredSize(new Dimension(350, 100));
    
    JPanel pane = new JPanel();
    pane.setLayout(new GridBagLayout());
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.top = 5;
    constraints.insets.bottom = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 80, 50, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
    pane.add(scrollPaneListe, constraints);
    setConstraints(constraints, 0, 1, 1, 1, 0, 50, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
    pane.add(scrollPaneInfo, constraints);
    
    JPanel paneRight = new JPanel(); // Pour mettre les deux boutons en haut et  droite
    paneRight.setLayout(new BoxLayout(paneRight,BoxLayout.Y_AXIS));
    paneRight.add(btnFermer);
    
    setConstraints(constraints, 1, 0, 1, 2, 20, 0, GridBagConstraints.NONE, GridBagConstraints.NORTHEAST);
    pane.add(paneRight, constraints);
    
    setContentPane(pane);
    listeValSelectionChanged();    
    
    pack();
    
  	
  }
  
  private void listeValSelectionChanged() {
  	int i = listeVal.getSelectedIndex();
  	if (i != -1) {
  		info.setText(listeVal.pointeurs.get(i).infoPourHistorique());
  		info.setCaretPosition(0);
  		pack();
  	}
  }
  
}
