package dialogs;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import mathgraph32.Global;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CMathGrafDoc;
import entreesSorties.MathGraphDataOutputStream;

@SuppressWarnings("serial")
public class ChoixImageFondDlg extends MtgDlg {
	private JFileChooser fc; // Ajout version 4.4 car les images sont dsormais enregistres dans le flux.
	private BufferedImage imageFond = null;
	private byte natImageFond;
	private boolean modification;
	
	class MyFilter extends javax.swing.filechooser.FileFilter {
		public boolean accept(File file) {
			if (file.isDirectory())
				return true;
			String filename = file.getName().toLowerCase();
			return filename.endsWith(Global.GLOBAL_JPG) || filename.endsWith(Global.GLOBAL_JPEG)
				|| filename.endsWith(Global.GLOBAL_GIF)	|| filename.endsWith(Global.GLOBAL_TIF) 
				|| filename.endsWith(Global.GLOBAL_TIFF) || filename.endsWith(Global.GLOBAL_PNG);
		}
		public String getDescription() {
			return Global.GLOBAL_ALL_GRAPHIC_EXTENSIONS;
		}
	}	
	
  public ChoixImageFondDlg(MtgFrame frameInit) {
    super (getString("chaineMenuChoixImageFond"), true, frameInit);
    initComponents();
   }
	
	public void initComponents() {
		if (!modification) {
			fc = new JFileChooser(MtgFrame.repertoireFichiers);
			fc.setApproveButtonText(getString("btnChoisir"));
			fc.setFileFilter(new MyFilter());
			// On ajoute un panneau de visualisation des fichiers image
			fc.setAccessory(new ImagePreview(fc));
	    fc.addActionListener(new java.awt.event.ActionListener() {
	      public void actionPerformed(java.awt.event.ActionEvent evt) {
	          if (evt.getActionCommand().equals(JFileChooser.CANCEL_SELECTION)){
	              dispose();
	          } else
	          	if (evt.getActionCommand().equals(JFileChooser.APPROVE_SELECTION)){
	           	 	setImage();
	        }
	      }
	    });
		}
		

    JPanel panePrincipal = new JPanel();
    panePrincipal.setLayout(new GridBagLayout());

		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets.bottom = 5;
		constraints.insets.top = 5;
		constraints.insets.left = 5;
		constraints.insets.right = 5;

		int line = 0;
		if (!modification) {
			setConstraints(constraints, 0, 0, 2, 1, 60, 50, GridBagConstraints.NONE, GridBagConstraints.WEST);
			panePrincipal.add(fc, constraints);
			line++;
		}
		setConstraints(constraints, 0, line++, 2, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
		setContentPane(panePrincipal);		
		pack();
		
	}

  private void setImage() {
		File file = fc.getSelectedFile();
  	try {
			imageFond = ImageIO.read(file);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			dialogueAvertissement(getString("echecImportationImage"));
			return;
		}
		String fileName = file.getName();
		natImageFond = MathGraphDataOutputStream.getNatImage(fileName);
		// Si le document possde dj une image de fond, on demande confirmation
		CMathGrafDoc doc = frame.cadreActif().document;
		if (doc.imageFond != null) {
			if (!frame.dialogueConfirmation_YES_NO(getString("confRemplImageFond"))) return;
		}
		doc.imageFond = imageFond;
		doc.natImageFond = natImageFond;
  	setRetourOK(true);
  	dispose();
  	MtgInternalFrame cadre = frame.cadreActif();
  	// Ligne suivante version 4.4.4 pour corriger un bug qui faisaint que si le mode Trace tait
  	// actif, on ne voyait pas l'image de fond aprs fermeture de la bote de dialogue.
  	cadre.effacetBuffer();
  	cadre.redessineSansCalcul();
  }
}
