/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import javax.swing.JTextField;

import types.*;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class EditeurNomCalcul extends JTextField {
  /** Creates a new instance of EditeurValeur */
  public EditeurNomCalcul() {
    super(8);
    setEditable(true); 
  }
  public static final boolean validationNomVariableOuCalcul(String ch)
  {
    boolean fini = false;
    while ((ch.length() != 1) && !fini)
    {
      if (ch.charAt(1) != ' ') fini = true;
      else ch = ch.substring(1);
    }
    if (ch.length() == 0) return false;
    char premierCar = ch.charAt(0);
    if (!FonteNom.lettre(premierCar)) return false;
    else
    {
      char carPrecedent = premierCar;
      boolean valable = true;
      for (int i = 1; (i <= ch.length()-1) && valable; i++)
      {
        char carEnCours = ch.charAt(i);
        // Cas d'une lettre
        if (FonteNom.lettre(carEnCours))
        {
          if (FonteNom.chiffre(carPrecedent) || FonteNom.prime(carPrecedent))
            valable = false;
        }
        else
        if (FonteNom.prime(carEnCours))
        {
          if (FonteNom.chiffre(carPrecedent) || FonteNom.prime(carPrecedent))
            valable = false;
        }
        else
        {
          if (!FonteNom.chiffre(carEnCours)) valable = false;
          carPrecedent = carEnCours;
        }
      }
      return valable;
    }
  }  
}
