/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.util.ListIterator;
import java.util.Vector;

import javax.swing.JList;
import javax.swing.ListSelectionModel;

import mathgraph32.MtgFrame;

import objets.CElementBase;
import objets.CListeObjets;
import objets.CMacro;
import types.NatureObjet;

@SuppressWarnings("serial")
public class ListeMacrosPourBoucle extends JList<String> {

  private CListeObjets liste; // La liste contenant les valeurs  afficher
  private int indiceMaxi; // l'indice maxi permis pour un objet  insrer dans la liste
  public Vector<CMacro> pointeurs;
	
  public ListeMacrosPourBoucle(CListeObjets listeInit, int indiceMaxiInit) {
    super();
    pointeurs = new Vector<CMacro>();
    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    liste = listeInit;
    indiceMaxi = indiceMaxiInit;
    int i = 0;
    
    Vector<String> values = new Vector<String> ();
    values.add(MtgFrame.getString("aucuneMacro"));
    // On ajoute les noms des objets de type macro  la liste
    ListIterator<CElementBase> li = liste.listIterator();
    while (i <= indiceMaxi)
    {
      CElementBase elb = li.next();
      if (!elb.estElementIntermediaire() && (elb.getNature() == NatureObjet.NMacro)) {
      	CMacro mac = (CMacro) elb;
      	if (mac.peutEtreMacroFinBoucle()) {
	        values.add(((CMacro)elb).intitule);
	        pointeurs.add((CMacro) elb);
      	}
      }
      i++;
    }
    setListData(values);
    setVisibleRowCount(5);
    setSelectedIndex(0);
  }
  
  public void setSel(CMacro mac) {
  	int ind = pointeurs.indexOf(mac);
  	if (ind == -1) setSelectedIndex(0);
  	else setSelectedIndex(ind + 1);
  }
  
  // Si le premier item a t slectionn c'est qu'aucune macro n'est slectionne
  public CMacro macroSelectionnee() {
  	int ind = getSelectedIndex() - 1;
  	if (ind == -1) return null;
  	else return (CMacro) pointeurs.get(ind);
  }   
}
