/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import objets.CListeObjets;
import objets.CRepere;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ModificationRepereDlg extends MtgDlg {
	
	private JButton btnModifier, btnFermer;
	private ListeReperes listeReperes;
	
  public ModificationRepereDlg(MtgFrame frameInit, int indiceMaxiInit) {
    super(getString("modificationRepereDlg1"),true, frameInit);
    initComponents();
    getRootPane().setDefaultButton(btnFermer);    
  }
  
  private void initComponents() {
    JLabel label1 = new JLabel(getString("modificationRepereDlg2"), JLabel.RIGHT);
    label1.setRequestFocusEnabled(false);  	
    btnModifier = new JButton(getString("btnModifier"));
    btnFermer = new JButton(getString("btnFermer"));
    btnFermer.setMaximumSize(btnModifier.getPreferredSize());
    btnModifier.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnModifierActionPerformed();
      }
    });    
    btnFermer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        btnFermerActionPerformed();
      }
    });
    // Spcial version applet
    // CListeObjets liste = frame.cadreActif().listePr;
    CListeObjets liste = frame.listePourConstruction();
    listeReperes = new ListeReperes(liste, liste.size() - 1);
    JScrollPane scrollPane = new JScrollPane(listeReperes, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    JPanel panePrincipal = new JPanel();
    panePrincipal.setLayout(new GridBagLayout());
    listeReperes.addMouseListener(new MouseListener() {

			public void mouseClicked(MouseEvent evt) {
				listeReperesMouseClicked();
			}

			public void mouseEntered(MouseEvent evt) {
			}

			public void mouseExited(MouseEvent evt) {
			}

			public void mousePressed(MouseEvent evt) {
			}

			public void mouseReleased(MouseEvent evt) {
			}
    });    
    
    GridBagConstraints constraints = new GridBagConstraints();
    constraints.insets.bottom = 5;
    constraints.insets.top = 5;
    constraints.insets.left = 5;
    constraints.insets.right = 5;
    
    setConstraints(constraints, 0, 0, 1, 1, 70, 30, GridBagConstraints.NONE, GridBagConstraints.WEST);
    panePrincipal.add(label1, constraints); 
    setConstraints(constraints, 0, 1, 1, 1, 0, 70, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
    panePrincipal.add(scrollPane, constraints);
    setConstraints(constraints, 1, 0, 1, 1, 30, 0, GridBagConstraints.NONE, GridBagConstraints.NORTH);
    panePrincipal.add(btnModifier, constraints); 
    setConstraints(constraints, 1, 1, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.NORTHEAST);
    panePrincipal.add(btnFermer, constraints);
    
    setContentPane(panePrincipal);
    pack();
  }
  
  private void btnModifierActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	CRepere rep = listeReperes.repereChoisi();
  	RepereDlg dlg = new RepereDlg(frame, rep, true);
  	dlg.setLocationRelativeTo(this);
  	dlg.setVisible(true);
  	if (dlg.retourOK()) {
		  cadre.listePr.metAJourObjetsDependantDe(rep);      		
  		cadre.repaintFigureAvecCalcul();
  		cadre.videListesPourConstructions();  // On remet  jour une construction ventuellement commence
  	}
  }
	
  private void btnFermerActionPerformed() {
  	dispose();
  }
  
  private void listeReperesMouseClicked() {
  	btnModifierActionPerformed();
  }
}
