/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JTextArea;
import mathgraph32.MtgFrame;

/**
 * Classe eprsentant un bouton servant  insrer un code Latex dans la bote de dialogue
 * de cration d'un affichage Latex
 * @author Yves
 *
 */
@SuppressWarnings("serial")
public class MtgLatexButton extends JButton implements ActionListener {
	protected String chaineLatex; // la chane latex que le bouton insrera
	protected int indiceInsertion; // L'indice dans cette chane aprs laquelle se fera l'insertion
	protected JTextArea textarea; // Le JTextArea associ au bouton dans lequel se fera l'insertion
  // private static Insets insets = new Insets(2,2,2,2);
  
  /**
   * Constructeur
   */
  public MtgLatexButton(String nomFichierInit, String chaineLatexInit, int indiceInsertionInit, JTextArea textareaInit) {
  	super(new ImageIcon(MtgFrame.class.getResource("images/" + nomFichierInit + ".png")));
  	chaineLatex = chaineLatexInit;
  	indiceInsertion = indiceInsertionInit;
  	textarea = textareaInit;
    // setMargin(insets);
  	setFocusable(false); // Important pour viter que le dialogue de caractres spciaux soit raffich
  	//  chaque fois qu'on presse le bouton
		addActionListener(this);
		setFocusPainted(false);  	
	}
  
	public void actionPerformed(ActionEvent e) {
	  String ch = textarea.getText();
		String selection = textarea.getSelectedText();
	  int i = textarea.getCaretPosition();
		if (selection != null) {
			textarea.setText(ch.substring(0,textarea.getSelectionStart()) + chaineLatex.substring(0, indiceInsertion)
					+ selection + chaineLatex.substring(indiceInsertion)
					+ ch.substring(textarea.getSelectionEnd()));
		}
		else {
	    String ch2 = ch.substring(0, i) + chaineLatex + ch.substring(i);
	    textarea.setText(ch2);
		}
		if (selection != null) textarea.setCaretPosition(textarea.getText().length());
		else {
			textarea.setCaretPosition(i + indiceInsertion);
		}
    // On informa la fentre propruitaire qu'elle doit si ncessaire remettre  jour
    //l'affichage clignotant (pour CommentaireDlg et LatexDlg)
    MtgDlg owner = (MtgDlg) (textarea.getTopLevelAncestor());
    owner.metAJourAffichageClignotant();
    textarea.requestFocus();
	}
}
