/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.BorderLayout;
import java.awt.Font;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class OptionsPreferencesDlg extends MtgDlg {
	private JTabbedPane tabbedPane;
	// private PanePreferencesChoixUniteAngle panePreferencesChoixUniteAngle;
	// private PanePreferencesNbColBarreOutils panePreferencesNbColBarreOutils;
	
	private PanePreferencesAnimation panePreferencesAnimation;
	// private PanePreferencesRepertoireFichiers panePreferencesRepertoireFichiers;
	// private PanePreferencesRepertoireConstructions panePreferencesRepertoireConstructions;
	// private PanePreferencesLangue panePreferencesLangue;
	private PanePreferencesNiveau panePreferencesNiveau;
	// private PanePreferencesTranslationFigure panePreferencesTranslationFigure;
	// private PanePreferencesPersonnalisationNiveau panePreferencesPersonnalisationNiveau;
	private PanePreferencesAntialiasing panePreferencesAntialiasing;
	private panePreferencesPressePapier panePreferencesPressePapier;
	
	private JButton btnOK;
	private JButton btnCancel;
	private int niveauPrec;
	
  public OptionsPreferencesDlg(MtgFrame frameInit) {
    super(getString("dialoguePreferences"),true, frameInit);
    // On mmorise le niveau actuel
    niveauPrec = frame.pref_niveau;
    // On mmorise le nombre de colonnes actuel de la barre d'outils et la taille
    /*
    nbColPrec = frame.pref_NbCol;
    coloredIconsPrec = frame.pref_ColoredIcons;
    littleIconsPrec = frame.pref_LittleIconSize;
    */
    tabbedPane = new JTabbedPane();
    tabbedPane.setFont(Font.decode("Dialog-13"));

    // panePreferencesChoixUniteAngle = new PanePreferencesChoixUniteAngle(frame);
    panePreferencesAnimation = new PanePreferencesAnimation(frame);
    // panePreferencesRepertoireFichiers = new PanePreferencesRepertoireFichiers(frame);
    // panePreferencesRepertoireConstructions = new PanePreferencesRepertoireConstructions(frame);
    // panePreferencesLangue = new PanePreferencesLangue(frame);
    panePreferencesNiveau = new PanePreferencesNiveau(frame);
    // panePreferencesTranslationFigure = new PanePreferencesTranslationFigure(frame);
    // panePreferencesNbColBarreOutils = new PanePreferencesNbColBarreOutils(frame);
    // panePreferencesPersonnalisationNiveau = new PanePreferencesPersonnalisationNiveau(frame);
    panePreferencesAntialiasing = new PanePreferencesAntialiasing(frame);
    panePreferencesPressePapier = new panePreferencesPressePapier(frame);
    
    // tabbedPane.addTab(panePreferencesChoixUniteAngle.titreOnglet(), null, panePreferencesChoixUniteAngle, null);
    // tabbedPane.addTab(panePreferencesNbColBarreOutils.titreOnglet(), null, panePreferencesNbColBarreOutils, null);
    if (frame.allowLevelChoice) tabbedPane.addTab(panePreferencesNiveau.titreOnglet(), null, panePreferencesNiveau, null);
    tabbedPane.addTab(panePreferencesAnimation.titreOnglet(), null, panePreferencesAnimation, null);
    // tabbedPane.addTab(panePreferencesRepertoireFichiers.titreOnglet(), null, panePreferencesRepertoireFichiers, null);   
    // tabbedPane.addTab(panePreferencesRepertoireConstructions.titreOnglet(), null, panePreferencesRepertoireConstructions, null); 
    // tabbedPane.addTab(panePreferencesLangue.titreOnglet(), null, panePreferencesLangue, null);
    // tabbedPane.addTab(panePreferencesTranslationFigure.titreOnglet(), null, panePreferencesTranslationFigure, null);
    tabbedPane.addTab(panePreferencesAntialiasing.titreOnglet(), null, panePreferencesAntialiasing, null);
    tabbedPane.addTab(panePreferencesPressePapier.titreOnglet(), null, panePreferencesPressePapier, null);
   
	  btnOK = new javax.swing.JButton(getString("btnOK"));
	  btnOK.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnOKActionPerformed();
	    }
	  });    
	  btnCancel = new javax.swing.JButton(getString("btnCancel"));
	  btnCancel.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnCancelActionPerformed();
	    }
	  });
	  btnOK.setPreferredSize(btnCancel.getPreferredSize());
    JPanel paneSouth = new JPanel();
    paneSouth.add(btnOK);
    paneSouth.add(btnCancel);
    getContentPane().setLayout(new BorderLayout());
    getContentPane().add("North", tabbedPane);
    getContentPane().add("South", paneSouth);
    getRootPane().setDefaultButton(btnOK);        
    pack();
  }
  
  private void btnCancelActionPerformed() {
  	dispose();
  }
  
  private void btnOKActionPerformed() {
  	// On regarde si le nombre de points pour animation est valide
  	if (!panePreferencesAnimation.donneesValides()) {
  		tabbedPane.setSelectedIndex(2);
  		return;
  	}
  	if (!panePreferencesPressePapier.donneesValides()) {
  		tabbedPane.setSelectedIndex(10);
  		return;  		
  	}
  	panePreferencesPressePapier.sauveDonnees();
  	/*
  	if (!panePreferencesRepertoireFichiers.donneesValides()) {
  		dialogueAvertissement(getString("ch49);
  		tabbedPane.setSelectedIndex(3);
  		return;
  	}
  	if (!panePreferencesRepertoireConstructions.donneesValides()) {
  		dialogueAvertissement(getString("ch49);
  		tabbedPane.setSelectedIndex(4);
  		return;  		
  	}
  	panePreferencesLangue.sauveDonnees();
  	panePreferencesChoixUniteAngle.sauveDonnees();
   	panePreferencesRepertoireFichiers.sauveDonnees();
  	panePreferencesRepertoireConstructions.sauveDonnees();
  	*/
	 	panePreferencesAnimation.sauveDonnees();
  	panePreferencesNiveau.sauveDonnees();
  	if (frame.allowLevelChoice && (niveauPrec != frame.pref_niveau)) {
  		frame.setLevel(5 - frame.pref_niveau);
  	}
  	panePreferencesAntialiasing.sauveDonnees();
  	// panePreferencesPersonnalisationNiveau.sauveDonnees();
  	/*
  	panePreferencesTranslationFigure.sauveDonnees();
  	panePreferencesNbColBarreOutils.sauveDonnees();
  	panePreferencesPersonnalisationNiveau.sauveDonnees();
  	// Si on a choisi le mode collge ou cole on impose le degr comme unit
  	if ((frame.pref_niveau >= MtgFrame.niveauMoyen) && (frame.pref_angleUnit == UniteAngle.Radian)) {
  		dialogueAvertissement(getString("ch166);
  		frame.pref_angleUnit = UniteAngle.Degre;
  	}
  	*/
  	// Si le niveau a chang on adapte les menus
  	/*
  	// Pour un changement de taille des icnes il faut redmarrer
		if ((frame.pref_LittleIconSize != littleIconsPrec) || (frame.pref_ColoredIcons != coloredIconsPrec)) {
			dialogueAvertissement(getString("redemarrageNecessaire);
		}
		*/  	
  	// Si le nombre de colonnes de la barre d'outils a chang ou si on a demand une taille diffrente d'icnes on la reconstruit
		/*
  	if (nbColPrec != frame.pref_NbCol) {
  		frame.prepareBarreOutils(nbColPrec);
  		if (frame.cadreActif() != null) frame.metAJourBoutonsBarreOutils(frame.cadreActif().document);
  		else frame.metAJourBoutonsBarreOutils(new CMathGrafDoc(frame));
  	}
  	frame.properties.setProperty("langage", frame.pref_langage);
  	String ch1;
		if (frame.pref_angleUnit == UniteAngle.Radian) ch1 = "radian"; else ch1 = "degree";
		frame.properties.setProperty("angleUnit", ch1);
		frame.properties.setProperty("moveNbPoints", Integer.toString(frame.pref_moveNbPoints));
		frame.properties.setProperty("moveFreq", Integer.toString(frame.pref_moveFreq));
		frame.properties.setProperty("moveCyclic", Boolean.toString(frame.pref_moveCyclic));
		frame.properties.setProperty("fileDirectory", frame.pref_fileDirectory);
		frame.properties.setProperty("constDirectory", frame.pref_constDirectory);
		frame.properties.setProperty("visualHelp", Boolean.toString(frame.pref_AideVisuelle));
		frame.properties.setProperty("FreeDisplaysTranslation", Boolean.toString(frame.pref_decalageAffichagesLibres));
		frame.properties.setProperty("NbColToolbar", Integer.toString(frame.pref_NbCol));
		frame.properties.setProperty("littleIconSize", Boolean.toString(frame.pref_LittleIconSize));
		frame.properties.setProperty("personalizedLevel", Boolean.toString(frame.pref_NiveauPersonnalise));
		frame.properties.setProperty("measuresDisplay1", Boolean.toString(frame.pref_affichageMesuresNiveau[0]));
		frame.properties.setProperty("measuresDisplay2", Boolean.toString(frame.pref_affichageMesuresNiveau[1]));
		frame.properties.setProperty("measuresDisplay3", Boolean.toString(frame.pref_affichageMesuresNiveau[2]));
		frame.properties.setProperty("measuresDisplay4", Boolean.toString(frame.pref_affichageMesuresNiveau[3]));
		frame.properties.setProperty("coloredIcons", Boolean.toString(frame.pref_ColoredIcons));
		*/
		
  	setRetourOK(true);
  	dispose();
  }  
	
}
