/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import mathgraph32.MtgColorButton;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class PaneOptionsFigureCouleurFond extends PaneOptionsFigure {
	private JLabel label1;
	private MtgColorButton colorButton;
	
	public PaneOptionsFigureCouleurFond(MtgInternalFrame cadreInit) {
    super(cadreInit);
    initComponents();
	}
	
	private void initComponents() {
		label1 = new JLabel(MtgFrame.getString("paneCouleurFond1"));
		colorButton = new MtgColorButton(cadre.frame);
		colorButton.couleur = cadre.couleurFond;
    setLayout(new GridBagLayout());

		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets.bottom = 5;
		constraints.insets.top = 5;
		constraints.insets.left = 5;
		constraints.insets.right = 5;

		MtgDlg.setConstraints(constraints, 0, 0, 1, 1, 600, 10, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
		add(label1, constraints);
		MtgDlg.setConstraints(constraints, 1, 0, 1, 1, 40, 10, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
		add(colorButton, constraints);
	}

	public boolean sauveDonnees() {
		cadre.couleurFond = colorButton.couleur;
		Color colorDoc = cadre.document.couleurFond;
		cadre.document.couleurFond = colorButton.couleur;
		cadre.commentaireDesignation().couleurFondAffichage = colorButton.couleur;
		cadre.couleurFondAffichage = colorButton.couleur;
		return (colorButton.couleur != colorDoc);
	}

	@Override
	public String titreOnglet() {
		return MtgFrame.getString("ongletCouleurFond");
	}
	
}
