/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class PanePreferencesNiveau extends PaneOptionsPreferences {
	
	private JLabel label1;
	private JRadioButton radioNiveauAvanceAvecComplexes;
	private JRadioButton radioNiveauAvanceSansComplexes;
	private JRadioButton radioNiveauMoyen;
	private JRadioButton radioNiveauElementaire;
	private ButtonGroup btnGroup;
	
	public PanePreferencesNiveau(MtgFrame frameInit) {
		super(frameInit);
		initComponents();
		radioNiveauAvanceAvecComplexes.setSelected(frameInit.pref_niveau == MtgFrame.niveauAvanceAvecComplexes);
		radioNiveauAvanceSansComplexes.setSelected(frameInit.pref_niveau == MtgFrame.niveauAvanceSansComplexes);
		radioNiveauMoyen.setSelected(frameInit.pref_niveau == MtgFrame.niveauMoyen);
		radioNiveauElementaire.setSelected(frameInit.pref_niveau == MtgFrame.niveauElementaire);
		
	}
	
	private void initComponents() {
		label1 = new JLabel(MtgFrame.getString("niveau"));
		// Modifi version 3.2.4. les descripteurs de niveau peuvent tre personnaliss
		radioNiveauAvanceAvecComplexes = new JRadioButton(frame.descripteurNiveau[1]);
		radioNiveauAvanceSansComplexes =  new JRadioButton(frame.descripteurNiveau[2]);
		radioNiveauMoyen = new JRadioButton(frame.descripteurNiveau[3]);
		radioNiveauElementaire = new JRadioButton(frame.descripteurNiveau[4]);
		btnGroup= new ButtonGroup();
		btnGroup.add(radioNiveauAvanceAvecComplexes);
		btnGroup.add(radioNiveauAvanceSansComplexes);
		btnGroup.add(radioNiveauMoyen);
		btnGroup.add(radioNiveauElementaire);
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		add(label1);
		add(radioNiveauElementaire);
		add(radioNiveauMoyen);
		add(radioNiveauAvanceSansComplexes);
		add(radioNiveauAvanceAvecComplexes);
		setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
	}
	
	public void sauveDonnees() {

		if (radioNiveauAvanceAvecComplexes.isSelected()) frame.pref_niveau = MtgFrame.niveauAvanceAvecComplexes;
		else if (radioNiveauAvanceSansComplexes.isSelected()) frame.pref_niveau = MtgFrame.niveauAvanceSansComplexes;
		else if (radioNiveauMoyen.isSelected()) frame.pref_niveau = MtgFrame.niveauMoyen;
		else frame.pref_niveau = MtgFrame.niveauElementaire;
		// On charge aussi le document qui spcifie les outils permis ou interdits nomm
		// default1.mgj pour le niveau lmentaire
		// default2.mgj pour le niveau collge
		// default3.mg pour le niveau avanc sans complexes
		// default4.mgj pour le niveau avanc avec complexes
		// On le cherche dans le dossier contenant le jar excutable.
		/* Inutile version Applet tous les fichiers de niveau ont t chargs dans un tableau
    String path = "/" + MtgFrame.class.getName().replace('.', '/') + ".class";
    URL url = getClass().getResource(path);
    try {
			path = URLDecoder.decode(url.toString(), "UTF-8");
		} catch (UnsupportedEncodingException e2) {
			path = "";
			return;
		}
		if (path.length() != 0) {
	    int index = path.lastIndexOf("/");
	    path = path.substring(0, index);
	    
	    // On enlve le jar:file: du dbut si ncessaire
	    if (path.startsWith("jar:file:"))
	    {
	      index = path.indexOf("!");
	      path = path.substring(9, index);
	    }
	    // On remonte de un niveau
	    index = path.lastIndexOf("/");
	    path = path.substring(0, index + 1);
	    if (path.startsWith("file:/")) path = path.substring(6);
		}
		String nomFichier;
		if (frame.pref_NiveauPersonnalise) nomFichier = "level" + Integer.toString(5-frame.pref_niveau) + ".mgj";
		else nomFichier = "default" + Integer.toString(5-frame.pref_niveau) + ".mgj";
		if (path.length() != 0){
			String ch2 = path + "Help" + frame.pref_langage + "/" + nomFichier;
			File file2 = new File(ch2);
			try {
				FileInputStream fis = new FileInputStream(file2);
				MathGraphDataInputStream inps = new MathGraphDataInputStream(fis);
				if (file2.exists()) {
					try {
						frame.docPreferencesOutils = new CMathGrafDoc(frame);
						frame.docPreferencesOutils.chargeDepuisFlux(inps);
					} catch (IOException e) { 
						frame.docPreferencesOutils = null;
					}
				}
			} catch (FileNotFoundException e) {
				frame.docPreferencesOutils = null;
			}			
		}
		// frame.chargePreferences();
		 * 
		 */
		// frame.creeMenu();
		// frame.creeBoutonsEtActions();
	}
	
	public String titreOnglet() {
		return MtgFrame.getString("ongletNiveau");
	}	
	
	
}
