/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package mathgraph32;

import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JToolBar;
import types.StyleMarqueAngle;

@SuppressWarnings("serial")
public class MtgPaneStyleMarqueAngle extends JPanel implements MouseListener {
	private MtgFrame frame;
	// Des boutons servant  dterminer le style des marques de segments cres
	private MtgStyleMarqueAngleButton buttonStyleMarqueAngle1;
	private MtgStyleMarqueAngleButton buttonStyleMarqueAngle2;
	private MtgStyleMarqueAngleButton buttonStyleMarqueAngle3;
	private MtgStyleMarqueAngleButton buttonStyleMarqueAngle4;
	private MtgStyleMarqueAngleButton buttonStyleMarqueAngle5;
	private MtgStyleMarqueAngleButton buttonStyleMarqueAngle6;
	private MtgStyleMarqueAngleButton buttonStyleMarqueAngle7;
	private MtgStyleMarqueAngleButton buttonStyleMarqueAngle8;
	private MtgStyleMarqueAngleButton buttonStyleMarqueAngle9;
	private MtgStyleMarqueAngleButton buttonStyleMarqueAngle10;
	// Un groupe de boutons pour englober tous les boutons de la barre d'outil de
	// choix de style de marque de segment
	private  ButtonGroup btngroupStyleMarqueAngle = new ButtonGroup();	
	// Les 5 barres d'outils horizontales servant  contenir les icnes de
	// choix de style de marque d'angle
	public  JToolBar barStyleMarqueAngle1 = new JToolBar(JToolBar.HORIZONTAL);
	private  JToolBar barStyleMarqueAngle2 = new JToolBar(JToolBar.HORIZONTAL);
	private  JToolBar barStyleMarqueAngle3 = new JToolBar(JToolBar.HORIZONTAL);
	private  JToolBar barStyleMarqueAngle4 = new JToolBar(JToolBar.HORIZONTAL);
	private  JToolBar barStyleMarqueAngle5 = new JToolBar(JToolBar.HORIZONTAL);
	
  /**
   * Constructeur
   */
  public MtgPaneStyleMarqueAngle(MtgFrame frameInit) {
    super();
    frame = frameInit;
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    
		buttonStyleMarqueAngle1 = new MtgStyleMarqueAngleButton(frame, StyleMarqueAngle.marqueSimple);
		buttonStyleMarqueAngle2 = new MtgStyleMarqueAngleButton(frame, StyleMarqueAngle.marqueSimple1Trait);
		buttonStyleMarqueAngle3 = new MtgStyleMarqueAngleButton(frame, StyleMarqueAngle.marqueSimple2Traits);
		buttonStyleMarqueAngle4 = new MtgStyleMarqueAngleButton(frame, StyleMarqueAngle.marqueSimple3Traits);
		buttonStyleMarqueAngle5 = new MtgStyleMarqueAngleButton(frame, StyleMarqueAngle.marqueSimpleCroix);
		buttonStyleMarqueAngle6 = new MtgStyleMarqueAngleButton(frame, StyleMarqueAngle.marquePleine);
		buttonStyleMarqueAngle7 = new MtgStyleMarqueAngleButton(frame, StyleMarqueAngle.marquePleine1Trait);
		buttonStyleMarqueAngle8 = new MtgStyleMarqueAngleButton(frame, StyleMarqueAngle.marquePleine2Traits);
		buttonStyleMarqueAngle9 = new MtgStyleMarqueAngleButton(frame, StyleMarqueAngle.marquePleine3Traits);
		buttonStyleMarqueAngle10 = new MtgStyleMarqueAngleButton(frame, StyleMarqueAngle.marquePleineCroix);
		Insets ins = new Insets(0, 0, 0, 0);
		barStyleMarqueAngle1.setMargin(ins);
		barStyleMarqueAngle2.setMargin(ins);
		barStyleMarqueAngle3.setMargin(ins);
 		barStyleMarqueAngle4.setMargin(ins);
 		barStyleMarqueAngle5.setMargin(ins);
		btngroupStyleMarqueAngle.add(buttonStyleMarqueAngle1);
		btngroupStyleMarqueAngle.add(buttonStyleMarqueAngle2);
		btngroupStyleMarqueAngle.add(buttonStyleMarqueAngle3);
		btngroupStyleMarqueAngle.add(buttonStyleMarqueAngle4);
		btngroupStyleMarqueAngle.add(buttonStyleMarqueAngle5);
		btngroupStyleMarqueAngle.add(buttonStyleMarqueAngle6);
		btngroupStyleMarqueAngle.add(buttonStyleMarqueAngle7);
		btngroupStyleMarqueAngle.add(buttonStyleMarqueAngle8);
		btngroupStyleMarqueAngle.add(buttonStyleMarqueAngle9);
		btngroupStyleMarqueAngle.add(buttonStyleMarqueAngle10);
		// On active la marque simple comme marque d'angle par dfaut
		buttonStyleMarqueAngle1.setSelected(true);
		barStyleMarqueAngle1.add(buttonStyleMarqueAngle1);
		barStyleMarqueAngle1.add(buttonStyleMarqueAngle2);
		barStyleMarqueAngle2.add(buttonStyleMarqueAngle3);
		barStyleMarqueAngle2.add(buttonStyleMarqueAngle4);
		barStyleMarqueAngle3.add(buttonStyleMarqueAngle5);
		barStyleMarqueAngle3.add(buttonStyleMarqueAngle6);
		barStyleMarqueAngle4.add(buttonStyleMarqueAngle7);
		barStyleMarqueAngle4.add(buttonStyleMarqueAngle8);
		barStyleMarqueAngle5.add(buttonStyleMarqueAngle9);
		barStyleMarqueAngle5.add(buttonStyleMarqueAngle10);
		barStyleMarqueAngle1.setBorder(BorderFactory.createEmptyBorder(1, 0, 1, 0));
		barStyleMarqueAngle2.setBorder(BorderFactory.createEmptyBorder(1, 0, 1, 0));
		barStyleMarqueAngle3.setBorder(BorderFactory.createEmptyBorder(1, 0, 1, 0));
		barStyleMarqueAngle4.setBorder(BorderFactory.createEmptyBorder(1, 0, 1, 0));
		barStyleMarqueAngle5.setBorder(BorderFactory.createEmptyBorder(1, 0, 1, 0));
		barStyleMarqueAngle1.setFloatable(false);
		barStyleMarqueAngle2.setFloatable(false);
		barStyleMarqueAngle3.setFloatable(false);
		barStyleMarqueAngle4.setFloatable(false);
		barStyleMarqueAngle5.setFloatable(false);
		
		add(barStyleMarqueAngle1);
		add(barStyleMarqueAngle2);
		add(barStyleMarqueAngle3);
		add(barStyleMarqueAngle4);
		add(barStyleMarqueAngle5);
    setToolTipText(MtgFrame.getString("tipChoixStyleMarqueAngle"));
    addMouseListener(this);
  }
  
  public Dimension taillePourScrollPane() {
  	Dimension d = barStyleMarqueAngle1.getPreferredSize();
  	return new Dimension(d.width, d.height*2 + 2);
  }
  
  public int verticalIncrement() {
  	return barStyleMarqueAngle1.getPreferredSize().height;
  }  
  
	public void mouseClicked(MouseEvent arg0) {
	}  
	public void mouseEntered(MouseEvent arg0) {
    if (getCursor() != MtgFrame.defaultCursor) frame.setCursor(MtgFrame.defaultCursor);
	}
	public void mouseExited(MouseEvent arg0) {
	}
	public void mousePressed(MouseEvent arg0) {
	}
	public void mouseReleased(MouseEvent arg0) {
	}  
}
