/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package mathgraph32;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JToggleButton;
import types.StyleRemplissage;



@SuppressWarnings("serial")
public class MtgStyleRemplissageButton extends JToggleButton implements MouseListener, ActionListener {
	private MtgFrame frame;
	private int styleRemplissageAssocie;
  // private static Insets insets = new Insets(0,0,0,0);
  
	public MtgStyleRemplissageButton(MtgFrame frameInit, int StyleRemplissageAssocieInit) {
		super(new ImageIcon(MtgFrame.class.getResource("images/" + nomFichierAssocie(StyleRemplissageAssocieInit))));
		// setMargin(insets);
		setBorder(BorderFactory.createEtchedBorder());
		frame = frameInit;
		styleRemplissageAssocie = StyleRemplissageAssocieInit;
	    addMouseListener(this);
	    addActionListener(this);
	    setToolTipText(MtgFrame.getString("tipChoixStyleHachure"));
	}
	
	public static String nomFichierAssocie(int styleRemplissage) {
		String ch;
		switch (styleRemplissage) {
			case StyleRemplissage.QuadrillagePleinTransp :
				ch = "StyleHachureTransp.png";
				break;
			case StyleRemplissage.QuadrillagePlein :
				ch = "StyleHachurePlein.png";
				break;
			case StyleRemplissage.Quadrillage45Bas :
				ch = "StyleHachure45Bas.png";
				break;
			case StyleRemplissage.Quadrillage45Haut :
				ch = "StyleHachure45Haut.png";
				break;
			case StyleRemplissage.QuadrillageHorizontal :
				ch = "StyleHachureHor.png";
				break;
			case StyleRemplissage.QuadrillageVertical :
				ch = "StyleHachureVer.png";
				break;
			default : ch = "";
		}
		return ch;
	}
	
	public void mouseClicked(MouseEvent e) {
	}

	public void mouseEntered(MouseEvent e) {
    if (getCursor() != MtgFrame.defaultCursor) frame.setCursor(MtgFrame.defaultCursor);
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}

	public void actionPerformed(ActionEvent e) {
		frame.styleRemplissageActif = styleRemplissageAssocie;
	}	

}
