/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package objets;
import types.Complexe;

/**
 *
 * @author Yves
 */
public class CConstantei extends CCalculBase {
  
  /** Creates a new instance of CConstantei */
  public CConstantei() {
  }
  /** Constructeur apour clonage */
  public CConstantei(CListeObjets liste)
  {
    super(liste);
  }
  
  @Override
  protected long nature() {
  	return natConstantei;
  }
  
  
  // Ajout pour la version 2.0 calculs sur les complexes.
  // Le rsultat est renvoy dans z
  public void resultatComplexe(boolean infoRandom, Complexe zRes) {
    /// Sera redfinie pour tous les descendants pouvant ne pas exister
    zRes.x = 0;// Par dfaut on suppose le calcul rel
    zRes.y = 1;
  }
  public CCalculBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    return new CConstantei(listeCible);
  }
  public CCalculBase getCopie() {
    return new CConstantei(listeProprietaire);
  }
  // Ajout pour la version 1.9.5
  // Procdure rcursive servant  savoir si un calcul dpend de la variable formelle
  public boolean  dependDeVariable(int ind) {
    return false;
  }
  
  @Override
	public String chaineCalcul(String[] varFor) {
		return "i";	
	}
  
  @Override
	public String chaineLatex(String[] varFor) {
		return "i\\,";	
	}
  
  @Override
	public boolean estConstant() {
		return true;
	}
  
	  
  
}
