/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package objets;

import java.awt.Color;

import dialogs.MacroDisparitionDlg;
import dialogs.MtgDlg;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

public class CMacroDisparition extends CMacroAvecListe {

  /** Creates new CMacroDisparition */
  public CMacroDisparition() {
  }
  
  // Constructeur pour clonage
  // Constructeur pour clonage
  public CMacroDisparition(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit, int encadrementInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit,
      CSousListeObjets listeAssocieeInit, int alignementHorizontalInit, int alignementVerticalInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit,
          encadrementInit, effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit, listeAssocieeInit,
          alignementHorizontalInit, alignementVerticalInit);
  }
  
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointLie);    
    int ind2 = listeSource.indexOf(impProto);        
    CSousListeObjets listeAssocieeClone = new CSousListeObjets();
    listeAssocieeClone.setImage(listeAssociee, listeSource, listeCible);
    CElementBase ptelb = new CMacroDisparition(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, 
      masque, (CPointAncetre)listeCible.get(ind1, CPointAncetre.class), indiceTaillePolice, encadrement,
      effacementFond, couleurFondAffichage, intitule, commentaireMacro, listeAssocieeClone,
      alignementHorizontal, alignementVertical);
    return ptelb;  
  }
  
  @Override
  public void actionDansPaint(MtgInternalFrame cadre) {
  	// Modifi pour la version 2.0
  	/*
    listeAssociee.effaceTout(cadre.gbuffer, cadre.dimf, true);
    listeAssociee.montreTout(false);
    cadre.afficheToutDansgbuffer();  
    */
    listeAssociee.montreTout(false);
  	cadre.redessineAvecCalcul();
    executionEnCours = false;
  }
  
  @Override
  public boolean modifiableParMenu() {
  	// Modification version 4.5.1
  	// return !estElementFinal;
  	return true;
  }
  
   @Override
  public MtgDlg dialogueModification(MtgFrame frame) {
  	return new MacroDisparitionDlg(frame, this, true);
  }
   
   @Override
   public String infoPourHistorique() {
     return getString("chinfo120");
   }

   @Override
   public void ajouteAntecedents(MtgFrame frame, CListeObjets liste) {
     liste.ajouteElementsDe(listeAssociee);
   }    
   
  
}
