/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import types.NatureCalcul;
import dialogs.AjoutGraduationRepereDlg;

public class OutilAjoutGraduationSimple extends Outil {
	public OutilAjoutGraduationSimple(MtgFrame frameInit) {
		super(frameInit, false); // false car pas de clignotement
	}

  @Override
	public void select() {
  	super.select();
		MtgInternalFrame cadre = frame.cadreActif();
		AjoutGraduationRepereDlg dlg = dialog();
		dlg.setLocationRelativeTo(null);
		dlg.setVisible(true);
    if (dlg.retourOK()) {
      cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil154"));    	
    }
    frame.activeOutilCapture();
  }
  
  protected AjoutGraduationRepereDlg dialog() {
  	return new AjoutGraduationRepereDlg(frame, false); 
  }
  
  @Override
	public boolean activationValide() {
  	// Modifi version Applet
		// return frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)>0;
  	return frame.listePourConstruction().nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)>0;
  }
	
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeRepere");
	}

}
