/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.CListeObjets;
import types.NatureCalcul;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import dialogs.CourbeFonctionDlg;

public class OutilCourbeFonction extends Outil {

  public OutilCourbeFonction(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    frame.indication("");
    CourbeFonctionDlg dlg = new CourbeFonctionDlg(frame);
		dlg.setLocationRelativeTo(null);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil113"));
      cadre.repaintFigureAvecCalcul();
    }
    frame.activeOutilCapture();
  }
  
  @Override
	public boolean activationValide() {
  	// Modifi version Applet
  	CListeObjets liste = frame.listePourConstruction();
		// return (frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)!=0)
		// 				&& (frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NFonction)!=0);
		return (liste.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)!=0)
						&& (liste.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NFonction)!=0);
	}
	
	@Override
	public String messageActivationNonValide() {
		String ch = "";
		if (frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)==0) ch = ch + getString("messagePasDeRepere") + "\n";
		if (frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NFonction)==0) ch = ch + getString("messagePasDeFonction");
		return ch;
	}	
  
}
