/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.*;
import mathgraph32.MtgFrame;


public class OutilDtAB extends OutilPar2pts {
  
  /** Creates a new instance of OutilDtAB */
  public OutilDtAB(MtgFrame frameInit) {
    super(frameInit);
  }

  @Override     
  public void creeObjet() {
    CDroiteAB pt = new CDroiteAB(frame.cadreActif().listePr, null, false,
      frame.couleurActive(), frame.styleTraitActif(), point1, point2, frame.pref_indiceTaillePoliceNom);
    if (frame.ajouteElementAvecVerification(pt))
      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil7"));
    annuleClignotement();
    select();
  }
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  @Override     
  public void ajouteObjetsVisuels() {
    CDroiteAB dt = new CDroiteAB(frame.listeObjetsVisuels, null, false,
      frame.couleurActive(), frame.styleTraitActif(),
      point1, frame.cadreActif().paneFigure.pointSouris, 2);
    frame.listeObjetsVisuels.add(dt);
  }
  @Override
  public String chaineIndication (int indEtape) {
    switch (indEtape) {
      case 1 : return getString("droiteAB1");
      case 2 : return getString("droiteAB2");
      default: return "";
    }
  }
}
