/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import types.NatureObjet;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

public class OutilExecutionMacro extends Outil {
	/** Creates a new instance of OutilExecutionMacro */
	public OutilExecutionMacro(MtgFrame frameInit) {
		super(frameInit, false);
	}

  @Override
	public void select() {
		super.select();
		frame.outilPointageActif = frame.outilPointageExecutionMacro;
		frame.outilPointageActif.designationDe(NatureObjet.NMacro);
		frame.outilPointageActif.reset(); // Ajout version 4.6
		frame.indication(getString("executionMacro1"));
	}
	
  @Override
	public void deselect() {
		MtgInternalFrame cadre = frame.cadreActif();
		if (cadre != null) {
			if (cadre.macroEnCours != null) {
			  cadre.macroEnCours.macroEnCours().termineAction(cadre);
			  cadre.macroEnCours = null;
			}
		}
		super.deselect();		
	}
  
  @Override
	public boolean activationValide() {
		return (frame.cadreActif().listePr.nombreObjetsParNatureVisibles(NatureObjet.NMacro) != 0);
	}
  
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeMacro");
	}	
  
}
