/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Cursor;
import java.awt.Point;

import mathgraph32.MtgFrame;
import objets.CElementGraphique;
import types.NatureObjet;

public class OutilGomme extends Outil {
	CElementGraphique objetDesigne;
	
	/** Creates a new instance of OutilPtLib */
	public OutilGomme(MtgFrame frameInit) {
		super(frameInit, false);
	}
	
  @Override
	public void select() {
		super.select();
		frame.outilPointageActif = frame.outilPointageCre;
		frame.outilPointageActif.designationDe(NatureObjet.NToutObjet);
		frame.indication(getString("masquerObjet1"));
	}
	
	@Override
  public Cursor curseurUtilise() {
		return MtgFrame.gommeCursor;
	}
	
	// Modifi pour la version java 2.0
	@Override
	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
		// objetDesigne = elg;
		// objetDesigne.efface(frame.cadreActif().gbuffer, true);
		// objetDesigne.effaceNom(frame.cadreActif().gbuffer);
		// objetDesigne.cache();
		elg.cache();
		frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil68"));
		frame.cadreActif().repaintFigureSansCalcul();
	}
}
