/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Cursor;
import java.awt.Point;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CAffichageLieAPoint;
import objets.CCommentaire;
import objets.CElementGraphique;
import objets.CListeObjets;
import objets.CMacroApparition;
import types.StyleEncadrement;
import dialogs.MacroApparitionAPartirAutreMacroDlg;

public class OutilMacroApparitionAPartirAutreMacro extends Outil {
  private CMacroApparition macroapp;
  
	public OutilMacroApparitionAPartirAutreMacro(MtgFrame frameInit) {
		super(frameInit, true);
	}

	@Override
	public Cursor curseurUtilise() {
		return MtgFrame.cornerCursor;
	}

  @Override
	public void select() {
		super.select();
		frame.outilPointageActif = frame.outilPointageClic;
		frame.indication(getString("macro1"));
	}

	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    int x = pointClique.x;
    int y = pointClique.y;
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets liste = cadre.listePr;
    // Avant l'affichage du dialogue on cre un message qui sera ajout  la liste des objets clignotants
    // pour matrialiser l'emplacement de l'affichage
    CCommentaire comClignotant = new CCommentaire(liste, null, false, frame.couleurActive(), x, y, 0d, 0d, false, null, 2,
    		StyleEncadrement.Sans, false, frame.cadreActif().couleurFond, getString("ch80"),
				CAffichageLieAPoint.alignementHorizontalGauche, CAffichageLieAPoint.alignementVerticalHaut);
    comClignotant.positionne(false, frame.cadreActif().dimf);
    ajouteClignotementDe(comClignotant);
    resetClignotement();
    macroapp = new CMacroApparition(liste, null, false, frame.couleurActive(), 
    		x, y, 0d, 0d, false, null, 2, StyleEncadrement.Effet3D, false, cadre.couleurFondAffichage, "", "", null, false,
    		CAffichageLieAPoint.alignementHorizontalGauche, CAffichageLieAPoint.alignementVerticalHaut);
    frame.indication("");
    MacroApparitionAPartirAutreMacroDlg dlg = new MacroApparitionAPartirAutreMacroDlg(frame, macroapp);
		dlg.setLocationRelativeTo(null);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
			if (frame.ajouteElementAvecVerification(macroapp)) {
			  frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil88"));
			  frame.cadreActif().repaintFigureAvecCalcul();
			}
			frame.activeOutilCapture();	
    }
    else {
    	annuleClignotement();
    	frame.activeOutilCapture();
    }
	}
}
