/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.CListeObjets;
import objets.CMarqueAngleOriente;
import mathgraph32.MtgFigurePanel;
import mathgraph32.MtgFrame;

/**
 *
 * @author Yves
 */
public class OutilMarqueAngleOriente extends OutilPar3pts {
  /** Creates a new instance of OutilBis */
  public OutilMarqueAngleOriente(MtgFrame frameInit) {
    super(frameInit);
  }

  @Override
  public void creeObjet() {
    CMarqueAngleOriente pt = new CMarqueAngleOriente(frame.cadreActif().listePr, null, false, 
       frame.couleurActive(), false, frame.styleTraitActif(), frame.styleMarqueAngleActif,
       16, frame.styleFlecheActif(), point1, point2, point3);
    if (frame.ajouteElementAvecVerification(pt))
      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil27"));
    annuleClignotement();
    // Provisoire
    select();
  }

  @Override
  public void ajouteObjetsVisuels() {
    CListeObjets liste = frame.listeObjetsVisuels;
    MtgFigurePanel pane = frame.cadreActif().paneFigure;
    CMarqueAngleOriente mar = new CMarqueAngleOriente(liste, null, false, frame.couleurActive(),
      false, frame.styleTraitActif(), frame.styleMarqueAngleActif, 16, frame.styleFlecheActif(),
      point1, point2, pane.pointSouris);
    liste.add(mar);
  }  
  @Override
  public String chaineIndication (int indEtape) {
    switch (indEtape) {
      case 1 : return getString("marqueAngleOriente1");
      case 2 : return getString("marqueAngleOriente2");
      case 3 : return getString("marqueAngleOriente3");
      default: return "";
    }
  }
}
