/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.CListeObjets;
import dialogs.ModificationFormuleDlg;
import mathgraph32.MtgFrame;

public class OutilModifierFormule extends Outil {
  public OutilModifierFormule(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
  public void select() {
    super.select();
    frame.indication(getString("modifierFormule1"));
    // Spcial version applet
    // ModificationFormuleDlg dlg = new ModificationFormuleDlg(frame, frame.cadreActif().listePr.size() - 1);
    ModificationFormuleDlg dlg = new ModificationFormuleDlg(frame, frame.listePourConstruction().size() - 1);
		dlg.setLocationRelativeTo(null);
    dlg.setVisible(true);
    // Il faut redonner le focus au frame car on peut avoir cr le dialogue d'affichage de valeurs en bas et  droite
		// frame.mtgDesktopPane.getDesktopManager().activateFrame(frame.cadreActif());	Supprim version Applet		
    frame.requestFocus();
    frame.activeOutilCapture();
  }
  
  @Override
  public boolean activationValide() {
  	// Modifi version Applet
  	// CListeObjets liste = frame.cadreActif().listePr;
  	CListeObjets liste = frame.listePourConstruction();
  	return (liste.nombreCalculsModifiablesParMenu() != 0);
  }
}
