/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 *
 * @author Yves
 * Objet anctre de tous les objets servant  traiter les clics de souris sur la figure
 */
package outils;

import java.awt.*;

import objets.CMathGrafDoc;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

public class OutilPointage {
  MtgFrame frame;
  Cursor curseurActif;
  long aDesigner;  // Nature des objets  dsigner pour l'outil de pointage
  // pour cration d'objets
  // Nouveau version 2.0 : Mis  true si dans paint de MtgFigurePanel.paint on doit redessiner la figure
  public boolean aRedessinerDansPaint;
 
  /** Creates a new instance of OutilPointage */
  public OutilPointage(MtgFrame frameInit) {
    frame = frameInit;
    aRedessinerDansPaint = false;
  }
  
  public void reset() {
    aRedessinerDansPaint = true;
  }
  
  /**
   * Version 2.0 :  redfinir pour les descendants
   * Ce qu'il faut faire dans paint pour rpondre aux actions de la souris
   */
  public void actionDansPaint(MtgInternalFrame cadre) {
  	if (frame.cadreActif() != cadre) return;	// Ajout version 4.7.4 pour viter des affichages intempestifs dans la mauvais
		// fentre lors des clignotements
  	if (frame.listeClignotante.size() == 0) return;
		CMathGrafDoc doc= cadre.document;
		cadre.effacegbuffer();
		Outil outilActif = frame.outilActif;
		if (outilActif.timer != null) {
    	if (outilActif.nbClignPair) {
    		// Ncessaire de ne pas afficher deux fois les mmes pour les affichages de surface avec transparence
    		// donc ne pas afficher les lemnts de listeClignotante (qui peuvent tre des objest provisoires
    		cadre.listePr.afficheToutSaufElementsDe(cadre.gbuffer, frame.cadreActif().dimf, true, doc.couleurFond,
    			doc.transparencePourSurfaces, frame.listeClignotante, frame.pref_antialiasing);
    		frame.listeClignotante.afficheTout(cadre.gbuffer, frame.cadreActif().dimf, true, doc.couleurFond,
    			doc.transparencePourSurfaces, frame.pref_antialiasing);
    	}
    	else cadre.listePr.afficheToutSaufElementsDe(cadre.gbuffer, cadre.dimf, true, doc.couleurFond,
    			doc.transparencePourSurfaces, frame.listeClignotante, frame.pref_antialiasing);
		}
		else cadre.afficheToutDansgbuffer();
		aRedessinerDansPaint = false;
  }
  
  public void setActiveCursor(Cursor cursor) {
    curseurActif = cursor;
  }

  public void designationDe(long nature) {
    aDesigner = nature;
  }
  
  public void mouseClicked(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
  }
  public void mouseMoved(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
  }
  public void mouseDragged(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
  }  
  public void mousePressed(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
  }
  public void mouseReleased(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
  }
  
  public static final String getString(String key) {
  	return MtgFrame.getString(key);
  }
  
}
