package outils;

import java.awt.Toolkit;

import mathgraph32.MtgFigurePanel;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

import objets.CListeObjets;
import objets.CMacro;
import objets.CMacroApparition;
import objets.CMacroSuiteMacros;
import objets.CPointAncetrePointsMobiles;
import types.InfoProx;
import types.NatureObjet;
import dialogs.PremierDernierDlg;

public class OutilPointageCapturePlusExecMacro extends OutilPointageCapt {
	
  /** Creates a new instance of OutilPointageCapt */
  public OutilPointageCapturePlusExecMacro(MtgFrame frameInit) {
    super(frameInit);
    // reset();
  }
	
  @Override
  public void mouseMoved(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
    MtgFigurePanel paneFigure = cadre.paneFigure;
    CListeObjets liste = cadre.listePr;
    InfoProx info = frame.infoProx;
    int nbObjetsProches = liste.procheDe
      (NatureObjet.NPointMobile | NatureObjet.NMacro, mouseEvent.getPoint(), info,
      frame.listeExclusionDesignation, true);
    boolean designationDejaAffichee = (cadre.commentaireDesignation().chaineCommentaire.length() != 0);
      // true si une dsignation est dj affiche prs du pointeur
    if (nbObjetsProches > 0) {
      String ch = new String ("");
      if (info.premierPointVoisin != null) {
        // ch = getString("capturer"); // Supprim version 4.7.4
        setActiveCursor(MtgFrame.handCursor);
      }
      else {
        ch = getString("executer");
        setActiveCursor(MtgFrame.defaultCursor);
      }
      cadre.commentaireDesignation().donneChaine(ch);
      cadre.commentaireDesignation().placeEn(0, 0);
      if (cadre.macroEnCours == null) {
        aRedessinerDansPaint = true;
        paneFigure.repaint();
      }
    }
    else {
      setActiveCursor(MtgFrame.crossHairCursor);
      cadre.videDesignation();
      if ((cadre.macroEnCours == null) && designationDejaAffichee) {
        aRedessinerDansPaint = true;
      	paneFigure.repaint();
      }
    }
  }
  
  public void mousePressed(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
    if (elementCapture != null) return;
    MtgFigurePanel paneFigure = cadre.paneFigure;
    CListeObjets liste = cadre.listePr;
    InfoProx info = frame.infoProx;
    int nbObjetsProches = info.nombreObjetsProches;
    if (nbObjetsProches > 0) {
      if (info.premierPointVoisin != null)
      { // A revoir si une macro est en cours d'excution
        // Priorit aux points mobiles
        if (info.nombrePointsVoisins == 1) {
          elementCapture = (CPointAncetrePointsMobiles) info.premierPointVoisin;
        }
        else {
          if (objetPredesigne != null) {
            if (objetPredesigne.distancePoint(mouseEvent.getX(), mouseEvent.getY(), true) <= 4) {
              elementCapture = objetPredesigne;
              objetPredesigne = null;
            }
          }
          else {
            PremierDernierDlg dlg = new PremierDernierDlg(frame);
            dlg.setLocationRelativeTo(null);
            dlg.setVisible(true);
            if (!dlg.retourOK()) return;
            // On regarde quelle a t la rponse de l'utilisateur
            if (dlg.getPremierChoisi()) objetPredesigne = (CPointAncetrePointsMobiles) info.premierPointVoisin;
            else objetPredesigne = (CPointAncetrePointsMobiles) info.dernierPointVoisin;
            return;
          }
        }
        natureElementCapture = elementCapture.getNature();
        cadre.listeDependantsDansPrincipale.retireTout();
        cadre.listeDependantsDansPrincipale.setListeDependantePourCapture(liste, elementCapture);
        // if ((appletMere.macroParDefaut != null) && (paneFigure.gbuffer != null)) 
        //  paneFigure.effacegBuffer();
      }
      else { // Cas d'une macro clique
        // L'objet macro est le NatureObjet.indiceMacro ime objet graphique
        CMacro macroCliquee = (CMacro) info.infoParType[NatureObjet.indiceMacro].premierVoisin;
        if (cadre.macroEnCours == null) { // Si aucune macro n'est dj en cours d'excution
                                    // on lance l'excution de la macro clique si possible
          if (macroCliquee.executionPossible()) {
            cadre.macroEnCours = macroCliquee;
            cadre.macroEnCours.initialise(cadre);
            cadre.macroEnCours.macroEnCours().actionAvantExecution(cadre);
            // Si la macro utilise un thread, il faut le crer.
            //  revoir
            cadre.macroEnCours.macroEnCours().initialiseInterruptions(cadre);

              //macroEnCours.execute(this, infRand, dimf);
            if (cadre.macroEnCours.macroEnCours().typeAnimation() == CMacro.sansAnimation) {
              //appletMere.macroEnCours.macroEnCours().actionDansPaint(appletMere);
              paneFigure.repaint();
            }
          }
          else Toolkit.getDefaultToolkit().beep();
        }
        else {
          CMacro mac = cadre.macroEnCours.macroEnCours();
          // Si la macro en cours d'excution s'excute par un thread et si elle n'a pas fini de s'excuter
          // on n'active pas une autre macro
          if ((mac.typeAnimation() == CMacro.animationParThread) && mac.executionEnCours) return;
          // Si la macro en cours est un CMacroSuiteMacros on la fait passer  la macro suivante            
          if (cadre.macroEnCours instanceof CMacroSuiteMacros) {
            if (mac.arretParClic()) {
              mac.termineAction(cadre);
              ((CMacroSuiteMacros) cadre.macroEnCours).passageMacroSuiv(cadre);
            }
          }
          else {
            if ((mac instanceof CMacroApparition) && mac.executionEnCours) {
              // mac.actionDansPaint(cadre);
              paneFigure.repaint();
              return;
            }
            if (macroCliquee == cadre.macroEnCours) {
              mac.termineAction(cadre);
              if (mac.typeAnimation() == CMacro.sansAnimation) {
                mac.actionAvantExecution(cadre);
                paneFigure.repaint();
              }
              else {
                mac.termineAction(cadre);
                cadre.macroEnCours = null;
                System.gc();
              }           
            }
            else {
              cadre.macroEnCours.termineAction(cadre);
              if (macroCliquee.executionPossible()) {
                cadre.macroEnCours = macroCliquee;
                cadre.macroEnCours.initialise(cadre);
                cadre.macroEnCours.actionAvantExecution(cadre);
                // Si la macro utilise un thread, il faut le crer.
                cadre.macroEnCours.initialiseInterruptions(cadre);

                  //macroEnCours.execute(this, infRand, dimf);
                if (mac.typeAnimation() == CMacro.sansAnimation) paneFigure.repaint();
              }
              else Toolkit.getDefaultToolkit().beep();
            }
          }
        }
      }
    }
    else {  // Si aucun objet n'est proche du pointeur souris, et si une macro est en cours
            // d'excution, on annule son excution
      if (cadre.macroEnCours != null) {
        if (cadre.macroEnCours instanceof CMacroSuiteMacros) {
          if (cadre.macroEnCours.macroEnCours().arretParClic()) {
            cadre.macroEnCours.macroEnCours().termineAction(cadre);
            ((CMacroSuiteMacros) cadre.macroEnCours).passageMacroSuiv(cadre);
          }
          // passageMacroSuiv redonne ventuellement un ordre paint() suivant la nature de la macro suivante
        }
        else {
          // Si la macro en cours est une macro d'apparition avec clic pour objet suivant
          // on ne la dsactive que si on est au dernier objet
          CMacro mac = cadre.macroEnCours.macroEnCours();
          if ((mac instanceof CMacroApparition) && mac.executionEnCours) {
            mac.actionDansPaint(cadre);
            paneFigure.repaint();
          }
          else {
            // modifi le 21/5/09
            // CMacro macEnCours = appletMere.macroEnCours;
            if (mac.arretParClic()) {
              mac.termineAction(cadre);
              cadre.macroEnCours = null;
            }
          }
          System.gc();
        }
      }
    }
  }

}
