/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/**
 * Outil de cration d'un point libre
 * @author Yves
 */
package outils;

import java.awt.*;

import objets.*;
import mathgraph32.MtgFrame;

public class OutilPtLib extends Outil{
  Point pointDesigne;
  
  /** Creates a new instance of OutilPtLib */
  public OutilPtLib(MtgFrame frameInit) {
    super(frameInit, false);
  }

  @Override
  public void select() {
    super.select();
    frame.outilPointageActif = frame.outilPointageClic;
    frame.indication(getString("pointLibre1"));
  }
  
	@Override
  public Cursor curseurUtilise() {
		return MtgFrame.crayonCursor;
	}
	
  @Override
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    pointDesigne = pointClique;
    creeObjet();
  }
  
  @Override
  public void creeObjet() {
    int x = pointDesigne.x;
    int y = pointDesigne.y;
    CPointBase pt = new CPointBase(frame.cadreActif().listePr, null, false,
      frame.couleurActive(), false, 0, 0, false, frame.genereNomPourPoint(), frame.pref_indiceTaillePoliceNom,
      frame.stylePointActif(), true, x, y, false);
    if (frame.ajouteElementAvecVerification(pt))
      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil1"));
    frame.cadreActif().repaintFigureAvecCalcul();
    select();
  }
}
