/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package outils;

import objets.CListeObjets;
import objets.CTestEquivalence;
import types.NatureCalcul;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import dialogs.TestEquivalenceDlg;

public class OutilTestEquivalence extends Outil {

  public OutilTestEquivalence(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
  @Override
  public void select() {
    super.select();
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets listePr = cadre.listePr;
    frame.indication("");
    CTestEquivalence testeq = new CTestEquivalence(listePr, null, false, "", null, null, true, false);
    TestEquivalenceDlg dlg = new TestEquivalenceDlg(frame, testeq, false);
		dlg.setLocationRelativeTo(null);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(testeq))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil82"));    	
    }
    frame.activeOutilCapture();
  }

  @Override
	public boolean activationValide() {
		return frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NCalculOuFonctionParFormule) != 0;
	}
	
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeCalculOuFonction");
	}	
  
}
