/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package types;

public class StyleMarqueAngle {
	public static final int marqueSimple = 1;
	public static final int marqueSimple1Trait = 1 << 1;
	public static final int marqueSimple2Traits = 1 << 2;
	public static final int marqueSimple3Traits = 1 << 3;
	public static final int marqueSimpleCroix = 1 << 4;
	public static final int marquePleine = 1 << 5;
	public static final int marquePleine1Trait = 1 << 6;
	public static final int marquePleine2Traits = 1 << 7;
	public static final int marquePleine3Traits = 1 << 8;
	public static final int marquePleineCroix = 1 << 9;
	
	public static final int marqueRemplie = marquePleine | marquePleine1Trait
		| marquePleine2Traits | marquePleine3Traits | marquePleineCroix;
	public static final int marqueAvecTrait = marqueSimple1Trait | marqueSimple2Traits | marqueSimple3Traits
		| marquePleine1Trait | marquePleine2Traits | marquePleine3Traits | marqueSimpleCroix | marquePleineCroix;
	
	public static final int styleMarqueSegment(int style) {
		switch (style) {
			case marqueSimple1Trait :
			case marquePleine1Trait :
				return StyleMarqueSegment.marqueSegment1;
			case marqueSimple2Traits :
			case marquePleine2Traits :
				return StyleMarqueSegment.marqueSegment2;
			case marqueSimple3Traits :
			case marquePleine3Traits :
				return StyleMarqueSegment.marqueSegment3;
			case marqueSimpleCroix :
			case marquePleineCroix :
				return StyleMarqueSegment.marqueSegment4;
			default :
				return StyleMarqueSegment.marqueSegment1;
		}
				
	}
}
